// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package swapserverrpc

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// WithdrawalServerClient is the client API for WithdrawalServer service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type WithdrawalServerClient interface {
	// WithdrawDeposits allows to cooperatively sweep deposits that haven't
	// timed out yet to the client's wallet. The server will generate the
	// partial sigs for the client's selected deposits.
	WithdrawDeposits(ctx context.Context, in *ServerWithdrawRequest, opts ...grpc.CallOption) (*ServerWithdrawResponse, error)
}

type withdrawalServerClient struct {
	cc grpc.ClientConnInterface
}

func NewWithdrawalServerClient(cc grpc.ClientConnInterface) WithdrawalServerClient {
	return &withdrawalServerClient{cc}
}

func (c *withdrawalServerClient) WithdrawDeposits(ctx context.Context, in *ServerWithdrawRequest, opts ...grpc.CallOption) (*ServerWithdrawResponse, error) {
	out := new(ServerWithdrawResponse)
	err := c.cc.Invoke(ctx, "/looprpc.WithdrawalServer/WithdrawDeposits", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// WithdrawalServerServer is the server API for WithdrawalServer service.
// All implementations must embed UnimplementedWithdrawalServerServer
// for forward compatibility
type WithdrawalServerServer interface {
	// WithdrawDeposits allows to cooperatively sweep deposits that haven't
	// timed out yet to the client's wallet. The server will generate the
	// partial sigs for the client's selected deposits.
	WithdrawDeposits(context.Context, *ServerWithdrawRequest) (*ServerWithdrawResponse, error)
	mustEmbedUnimplementedWithdrawalServerServer()
}

// UnimplementedWithdrawalServerServer must be embedded to have forward compatible implementations.
type UnimplementedWithdrawalServerServer struct {
}

func (UnimplementedWithdrawalServerServer) WithdrawDeposits(context.Context, *ServerWithdrawRequest) (*ServerWithdrawResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method WithdrawDeposits not implemented")
}
func (UnimplementedWithdrawalServerServer) mustEmbedUnimplementedWithdrawalServerServer() {}

// UnsafeWithdrawalServerServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to WithdrawalServerServer will
// result in compilation errors.
type UnsafeWithdrawalServerServer interface {
	mustEmbedUnimplementedWithdrawalServerServer()
}

func RegisterWithdrawalServerServer(s grpc.ServiceRegistrar, srv WithdrawalServerServer) {
	s.RegisterService(&WithdrawalServer_ServiceDesc, srv)
}

func _WithdrawalServer_WithdrawDeposits_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ServerWithdrawRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WithdrawalServerServer).WithdrawDeposits(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/looprpc.WithdrawalServer/WithdrawDeposits",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WithdrawalServerServer).WithdrawDeposits(ctx, req.(*ServerWithdrawRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// WithdrawalServer_ServiceDesc is the grpc.ServiceDesc for WithdrawalServer service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var WithdrawalServer_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "looprpc.WithdrawalServer",
	HandlerType: (*WithdrawalServerServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "WithdrawDeposits",
			Handler:    _WithdrawalServer_WithdrawDeposits_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "withdraw.proto",
}
